"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Compare = exports.Handdle = void 0;
var app_1 = require("./app");
var Handdle;
(function (Handdle) {
    var make = function (data, key) {
        if (data.value.tag === "text") {
            //const myDom = document.createElement(`var-text`);
            var myDom = document.createTextNode(data.value.myClass.states["value"]);
            //myDom.appendChild(element);
            return myDom;
        }
        else {
            var myDom = document.createElement(data.value.tag);
            var states = data.value.myClass.states;
            for (var name_1 in states) {
                var data_1 = states[name_1];
                if (typeof data_1 === "string")
                    myDom.setAttribute(name_1, data_1);
                if (name_1.length > 2 && name_1.split("").splice(0, 2).join("") === "on")
                    myDom.addEventListener("onclick".split("").splice(2).join(""), app_1.App.vars[key].value.myClass.states[name_1]);
            }
            return myDom;
        }
    };
    Handdle.add = function (parentEl, data, key) {
        var realDom = make(data, key);
        data.realDom = realDom;
        parentEl.appendChild(realDom);
    };
    Handdle.change = function (parentEl, target, data, key) {
        var realDom = make(data, key);
        data.realDom = realDom;
        parentEl.replaceChild(realDom, target);
    };
    Handdle.changeState = function (el, lastStates, nowStates) {
        //add & change
        for (var name_2 in nowStates) {
            var value = nowStates[name_2];
            if (typeof value === "string") {
                // new & change
                if ((lastStates[name_2] === undefined || lastStates[name_2] !== value) && name_2 !== "value")
                    el.setAttribute(name_2, value);
            }
            // text change
            if (name_2 === "value" && lastStates[name_2] !== value)
                el.nodeValue = value;
        }
        // del
        for (var name_3 in lastStates) {
            var value = lastStates[name_3];
            if (typeof value === "string") {
                // new & change
                if (nowStates[name_3] === undefined)
                    el.removeAttribute(name_3);
            }
        }
    };
    Handdle.del = function (data) {
        data.remove();
    };
})(Handdle = exports.Handdle || (exports.Handdle = {}));
var Change;
(function (Change) {
    Change.lastElements = function (last, now) {
        var calcMax = function (a, b) { return a.length > b.length ? a : b; };
        var table = Array.from(Array(last.length), function () { return new Array(now.length); });
        var doTableX = [];
        var doTableY = [];
        now.map(function (valy, y) {
            last.map(function (valx, x) {
                var nowVal = [];
                if (x > 0 || y > 0) {
                    if (x > 0 && y > 0)
                        nowVal = __spreadArray([], calcMax(table[x - 1][y], table[x][y - 1]), true);
                    else if (x > 0)
                        nowVal = __spreadArray([], table[x - 1][y], true);
                    else
                        nowVal = __spreadArray([], table[x][y - 1], true);
                }
                if (valx.key === valy.key && doTableY[y] === undefined && doTableX[x] === undefined) {
                    nowVal = __spreadArray(__spreadArray([], nowVal, true), [new app_1.App.Location(valy.key, valy.loc)], false);
                    doTableX[x] = true;
                    doTableY[y] = true;
                }
                table[x][y] = nowVal;
            });
        });
        if (last.length === 0)
            return last;
        if (now.length === 0)
            return now;
        return table[last.length - 1][now.length - 1];
    };
    Change.getDiff = function (data, compareData) {
        var returnData = [];
        data.map(function (e) {
            if (compareData.find(function (e1) { return e1.key === e.key; }) === undefined)
                returnData.push(e);
        });
        return returnData;
    };
})(Change || (Change = {}));
var Compare;
(function (Compare) {
    // eslint-disable-next-line prefer-const
    Compare.lastData = [];
    // eslint-disable-next-line prefer-const
    Compare.nowData = [];
    var delChildKey = function (lastData, startPoint) {
        lastData[startPoint].keys.map(function (e) {
            if (lastData[e.loc] !== undefined)
                delChildKey(lastData, e.loc);
        });
        lastData[startPoint] = undefined;
    };
    Compare.render = function (startPoint) {
        // dynamic
        if (app_1.App.vars[startPoint].keys.length === 0 || app_1.App.vars[startPoint].keys[0].key !== -1) {
            // not first time
            if (Compare.lastData[startPoint] !== undefined) {
                var ntChange = Change.lastElements(Compare.lastData[startPoint].keys, Compare.nowData[startPoint].keys);
                var add = Change.getDiff(Compare.nowData[startPoint].keys, ntChange);
                var del = Change.getDiff(Compare.lastData[startPoint].keys, ntChange);
                // change states
                for (var _i = 0, ntChange_1 = ntChange; _i < ntChange_1.length; _i++) {
                    var e = ntChange_1[_i];
                    var lastState = Compare.lastData[e.loc].value.myClass.states;
                    var nowState = Compare.nowData[e.loc].value.myClass.states;
                    Handdle.changeState(app_1.App.vars[e.loc].realDom, lastState, nowState);
                }
                // add
                for (var _a = 0, add_1 = add; _a < add_1.length; _a++) {
                    var e = add_1[_a];
                    Handdle.add(app_1.App.vars[startPoint].realDom, app_1.App.vars[e.loc], e.loc);
                }
                // del
                for (var _b = 0, del_1 = del; _b < del_1.length; _b++) {
                    var e = del_1[_b];
                    Handdle.del(app_1.App.vars[e.loc].realDom);
                }
            }
            // first time
            else {
                Compare.nowData[startPoint].keys.map(function (e) {
                    Handdle.add(app_1.App.vars[startPoint].realDom, app_1.App.vars[e.loc], e.loc);
                });
            }
        }
        // static
        else {
            for (var _c = 0, _d = app_1.App.vars[startPoint].keys; _c < _d.length; _c++) {
                var e = _d[_c];
                var lastS = Compare.lastData[e.loc];
                var nowS = app_1.App.vars[e.loc];
                if (lastS === undefined)
                    Handdle.add(app_1.App.vars[startPoint].realDom, app_1.App.vars[e.loc], e.loc);
                else if (nowS === undefined)
                    Handdle.del(lastS.realDom);
                else if (lastS.value.tag !== nowS.value.tag) {
                    Handdle.change(app_1.App.vars[startPoint].realDom, lastS.realDom, nowS, e.loc);
                    delChildKey(Compare.lastData, e.loc);
                }
                else
                    Handdle.changeState(app_1.App.vars[e.loc].realDom, lastS.value.myClass.states, nowS.value.myClass.states);
            }
        }
        // repeat
        app_1.App.vars[startPoint].keys.map(function (index) { return Compare.render(index.loc); });
    };
})(Compare = exports.Compare || (exports.Compare = {}));
//# sourceMappingURL=htmlHandle.js.map